uniform float visibility;
uniform float wobblePhase;

varying vec3 MCposition;

// lighting per vertex - ambient and diffuse only

void main()
{
  vec3 lightDir, normal;
  vec4 ambient, globalAmbient;

  vec4 vertex = vec4(gl_Vertex); // we want to modify the vertex. The ATI compiler doesn't like me modifying gl_Vertex
  
  // Wobble ! beware the magic numbers ooooo....
  // max wobble when wobblePhase is 0.5, zero wobble when 0.0 and 1.0. putting wobblePhase inside the sin makes the wave move.
  vertex.y += (sin((vertex.x + wobblePhase*2.0) * 20.0) + sin((vertex.z + wobblePhase*2.0) * 20.0)) * 0.10 * (1.0 - abs(wobblePhase - 0.5) * 2.0);
  

  normal = normalize(gl_NormalMatrix * gl_Normal);
  lightDir = normalize(vec3(gl_LightSource[0].position - gl_ModelViewMatrix*vertex));


	ambient = gl_FrontMaterial.ambient * gl_LightSource[0].ambient;
	globalAmbient = gl_LightModel.ambient * gl_FrontMaterial.ambient;

  // Diffuse is dot product of light vector and normal
  float diffuse = max(dot(lightDir, normal), 0.0);

  gl_FrontColor = globalAmbient + ambient + gl_FrontLightProduct[0].diffuse * diffuse;
  // don't worry about specular, these balls aren't shiny
  
  MCposition = vec3(vertex);

  //gl_Position = ftransform();
  gl_Position = gl_ModelViewProjectionMatrix * vertex;
}
