varying vec4 ProjShadow;
uniform sampler2D Texture;
uniform sampler2DShadow ShadowMap;

uniform int multiShadows;

void main() {
  const float offset = 0.02;

  float shadow;
	float shadow0 = shadow2DProj(ShadowMap, ProjShadow).r;
	
	if (multiShadows == 1) {
	  float shadow1 = shadow2DProj(ShadowMap, ProjShadow + vec4(0.0, offset, 0.0, 0.0)).r;
	  float shadow2 = shadow2DProj(ShadowMap, ProjShadow + vec4(offset, offset, 0.0, 0.0)).r;
	  float shadow3 = shadow2DProj(ShadowMap, ProjShadow + vec4(offset, 0.0, 0.0, 0.0)).r;
	  shadow = 0.25 * (shadow0 + shadow1 + shadow2 + shadow3);
	} else {
	  shadow = shadow0;
	}
	
  float shadowVis = .7+(shadow*.3); // shadow has 30% opacity
  
  // texture
  vec3 texel = texture2D(Texture, gl_TexCoord[0].st).rgb;
  
  gl_FragColor = vec4(vec3(gl_Color) * shadowVis * texel, 1);
}


