varying vec4 ProjShadow;

// lighting per vertex - ambient and diffuse only

void main() {
  vec3 normal, lightDir;
  vec4 diffuse, ambient;

	// first transform the normal into eye space and normalize the result
	normal = normalize(gl_NormalMatrix * gl_Normal);
	
	// directional light?
	lightDir = normalize(vec3(gl_LightSource[0].position - gl_ModelViewMatrix*gl_Vertex));
	
	// work out ambient and diffuse for the fragment shader
	diffuse = gl_FrontMaterial.diffuse * gl_LightSource[0].diffuse;
	ambient = gl_FrontMaterial.ambient * gl_LightSource[0].ambient + gl_LightModel.ambient * gl_FrontMaterial.ambient;

  // combine
  gl_FrontColor = ambient + diffuse * max(dot(normal,lightDir),0.0);

  // for the shadows
	ProjShadow = gl_TextureMatrix[1] * gl_Vertex;
	
	// texture mapping
	gl_TexCoord[0] = gl_MultiTexCoord0;


	gl_Position = ftransform();		
}